package accesspoint;
import java.io.File;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.LinkedList;
import message.*;
public class FileServerAccess {
    private LinkedList<String> fileList;
    private String ip;
    private int port;
    public FileServerAccess (String ip, int port) {
        fileList = new LinkedList<String>();
        this.ip = ip;
        this.port = port;
    }
    public boolean getFile (String name, String type, long lastModified) {
        Socket socket = null;
        try {
            socket = new Socket(this.ip, this.port);
        }
        catch (Exception e) {
            System.out.println("ERROR - No se ha creado el socket al servidor: "+e);
            return false;
        }
        if (socket != null) {
            ObjectOutputStream oos;
            try {
                oos = new ObjectOutputStream(socket.getOutputStream());
            }
            catch (Exception e) {
                System.out.println("ERROR - No ha sido posible obtener el stream de salida: "+e);
                return false;
            }
            try {
                RequestFileMessage requestMessage = new RequestFileMessage();
                requestMessage.name = name;
                requestMessage.type = type;
                requestMessage.lastModified = lastModified;
                oos.writeObject(requestMessage);
            }
            catch (Exception e) {
                System.out.println("ERROR - No se ha enviado el mensaje de peticion correctamente: "+e);
                return false;
            }
            FileOutputStream fos;
            ObjectInputStream ois;
            SendFileMessage receivedMessage;
            Object receivedObject;
            File tempFile;
            try {
                fos = new FileOutputStream("./"+type+"/.temp"+name);
            }
            catch (Exception e) {
                System.out.println("ERROR - No se ha creado el fichero nuevo: "+e);
                return false;
            }
            try {
                ois = new ObjectInputStream(socket.getInputStream());
            }
            catch (Exception e) {
                System.out.println("ERROR - No ha podido asociarse correctamente el stream de entrada de objetos: "+e);
                return false;
            }
            do {
                try {
                    receivedObject = ois.readObject();
                }
                catch (Exception e) {
                    System.out.println ("ERROR - No ha podido leerse el objeto recibido: "+e);
                    return false;
                }
                if (receivedObject instanceof SendFileMessage) {
                    receivedMessage = (SendFileMessage)receivedObject;
                    if ((receivedMessage.name.equals(name))&&(receivedMessage.info.equals("NotModified"))) {
                        System.out.println("FILESERVERACCESS NotModified");
                        try {
                            fos.close();
                        }
                        catch (Exception e) {
                            System.out.println("WARNING - No se ha cerrado el stream de manera correcta: "+e);
                        }
                        tempFile = new File ("./"+type+"/.temp"+name);
                        tempFile.delete();
                        return true;
                    }
                    if ((receivedMessage.name.equals(name))&&(receivedMessage.info.equals("NotFound"))) {
                        System.out.println("FILESERVERACCESS NotFound");
                        try {
                            fos.close();
                        }
                        catch (Exception e) {
                            System.out.println("WARNING - No se ha cerrado el stream de manera correcta: "+e);
                        }
                        tempFile = new File ("./"+type+"/.temp"+name);
                        tempFile.delete();
                        return true;
                    }
                    try {
                        fos.write(receivedMessage.fileContent, 0, receivedMessage.validBytes);
                    }
                    catch (Exception e) {
                        System.out.println ("ERROR - No se ha escrito correctamente el fichero recibido: "+e);
                        return false;
                    }
                }
                else {
                    System.err.println("WARNING - Mensaje recibido no esperado "+receivedObject.getClass().getName());
                    break;
                }
            } while (!receivedMessage.last);
            tempFile = new File ("./"+type+"/.temp"+name);
            File newFile = new File ("./"+type+"/"+name);
            if (!tempFile.renameTo(newFile)) {
                System.out.println("ERROR - Renombrado de fichero temporal incorrecto");
            }
            tempFile.delete();
            try {
                fos.close();
                ois.close();
                socket.close();
            }
            catch (Exception e) {
                System.out.println("WARNING - No se han cerrado los streams y el socket de manera correcta: "+e);
            }
            this.fileList.add(name);
            return true;
        }
        else {
            System.out.println("ERROR - Fichero no obtenido");
            return false;
        }
    }
    public boolean hasFile (String File) {
        if (this.fileList.contains(File)) {
            return true;
        }
        else {
            return false;
        }
    }
}