package database;

import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;

public class DatabaseAccess {

    private String url; //"jdbc:mysql://localhost:3306/blueMall?user=root&password=.GRC0510";
    private String ip;
    private int port;
    private String database;
    private String user;
    private String password;
    private java.sql.Connection conn;

    public DatabaseAccess() {
        this.ip = "localhost";
        this.port = 3306;
        this.database = "blueMall";
        this.user = "root";
        this.password = ".GRC0510";
        this.url = "jdbc:mysql://" + this.ip + ":" + this.port + "/" + this.database + "?user=" + this.user + "&password=" + this.password;
    }
    //Adds a new device in the database, including a new visit atached to it
    //Returns TRUE if a new device is inserted and FALSE if that device already exists and mustn't be added
    public boolean addDevice(String friendlyName, String bta, int zone) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetDevice, resultSetExist;
        try {
            resultSetExist = statement.executeQuery("SELECT * FROM `" + this.database + "`.`device` where `mac` like '" + bta + "'");
            if (!resultSetExist.first()) {
                resultSetDevice = statement.executeQuery("SELECT * FROM `" + this.database + "`.`device`");
                resultSetDevice.moveToInsertRow();
                resultSetDevice.updateString("name", friendlyName);
                resultSetDevice.updateString("mac", bta);
                resultSetDevice.updateInt("lastVisit", this.addVisit(bta, zone));
                resultSetDevice.insertRow();
                resultSetDevice.close();
            } else {
                return false;
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return true;
    }
    //Adds a new service route to the database
    public void addServiceRoute(String bta, String route) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetService;
        try {
            if (!this.isServiceRoute(bta)) {
                resultSetService = statement.executeQuery("SELECT * FROM `" + this.database + "`.`service`");
                resultSetService.moveToInsertRow();
                resultSetService.updateString("device", bta);
                resultSetService.updateString("route", route);
                resultSetService.insertRow();
                resultSetService.close();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    //Adds a new visit for the specific device in the database
    //Returns the visit's identifier
    public int addVisit(String bta, int zone) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetVisit, resultSetUpdateVisit;
        int visitID = 0;
        try {
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Date date = new Date();
            date = new Date(date.getTime());
            resultSetVisit = statement.executeQuery("SELECT * FROM `" + this.database + "`.`visit`");
            resultSetVisit.moveToInsertRow();
            resultSetVisit.updateString("device", bta);
            resultSetVisit.updateInt("zone", zone);
            resultSetVisit.updateString("visitDate", format.format(date));
            resultSetVisit.insertRow();
            resultSetVisit.close();
            resultSetVisit = statement.executeQuery("SELECT * FROM `" + this.database + "`.`visit` WHERE `" + this.database + "`.`visit`.`device` LIKE '" + bta + "' AND `" + this.database + "`.`visit`.`zone` LIKE '" + zone + "' ORDER BY `visitDate` DESC");
            if (resultSetVisit.first()) {
                visitID = resultSetVisit.getInt("id");
                resultSetVisit.close();
                resultSetUpdateVisit = statement.executeQuery("SELECT * FROM `" + this.database + "`.`device` WHERE `" + this.database + "`.`device`.`mac` LIKE '" + bta + "'");
                if (resultSetUpdateVisit.first()) {
                    resultSetUpdateVisit.updateInt("lastVisit", visitID);
                    resultSetUpdateVisit.updateRow();
                }
                resultSetUpdateVisit.close();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return visitID;
    }
    //Gets the service route associated to this mac
    public String getServiceRoute(String bta) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetService;
        String route = null;
        try {
            resultSetService = statement.executeQuery("SELECT * FROM `" + this.database + "`.`service` WHERE `" + this.database + "`.`service`.`device` LIKE '" + bta + "'");
            if (resultSetService.first()) {
                route = resultSetService.getString("route");
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return route;
    }
    //Checks if the mac corresponds to an employee's deviceç
    public boolean isEmployeeDevice(String bta) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetService;
        try {
            resultSetService = statement.executeQuery("SELECT * FROM `" + this.database + "`.`employeeDevice` WHERE `" + this.database + "`.`employeeDevice`.`mac` LIKE '" + bta + "'");
            if (resultSetService.first()) {
                return true;
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }return false;
    }
    //Checks if now is the employee device's owner working to ignore sending ads
    public boolean isWorkingEmployee(String bta) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetEmployee;
        String startTime, endTime, nowTime;
        try {
            SimpleDateFormat format = new SimpleDateFormat("HH:mm:ss");
            Date now = new Date();
            now = new Date(now.getTime());
            nowTime = format.format(now);
            resultSetEmployee = statement.executeQuery("SELECT * FROM `" + this.database + "`.`employeeDevice` WHERE `" + this.database + "`.`employeeDevice`.`mac` LIKE '" + bta + "'");
            if (resultSetEmployee.first()) {
                startTime = resultSetEmployee.getString("startTime");
                endTime = resultSetEmployee.getString("endTime");
                if (((startTime.compareTo(nowTime)) < 0) && ((endTime.compareTo(nowTime)) > 0)) {
                    return true;
                }
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return false;
    }
    //Checks if the device's last visit is old enough to consider now as a new visit
    public boolean isNewVisit(String bta, int zone, long newVisit) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetVisit;
        try {
            resultSetVisit = statement.executeQuery("SELECT * FROM `" + this.database + "`.`visit` WHERE `device` LIKE '" + bta + "' AND `zone` LIKE '" + zone + "' ORDER BY `visitDate` DESC");
            if (resultSetVisit.first()) {
                Date now = new Date();
                SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                now = new Date(now.getTime());
                String lastVisit = resultSetVisit.getString("visitDate");
                try {
                    Date last = format.parse(lastVisit);
                    Date recentDate = new Date(last.getTime() + newVisit);
                    if (now.before(recentDate)) {
                        return false;
                    }
                } catch (ParseException e) {
                    System.out.println(e);
                }
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return true;
    }
    //Checks if there is a service route for this mac
    public boolean isServiceRoute(String bta) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetService;
        try {
            resultSetService = statement.executeQuery("SELECT * FROM `" + this.database + "`.`service` WHERE `" + this.database + "`.`service`.`device` LIKE '" + bta + "'");
            if (resultSetService.first()) {
                return true;
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return false;
    }
    //Checks if the general advertisement has been sent before to that device
    public boolean isGeneralAdSent(int id, String bta) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetAdSent;
        try {
            resultSetAdSent = statement.executeQuery("SELECT * FROM `" + this.database + "`.`sentGeneralAd` WHERE `" + this.database + "`.`sentGeneralAd`.`device` LIKE '" + bta + "' AND `" + this.database + "`.`sentGeneralAd`.`advertisement` LIKE '" + id + "'");
            if (resultSetAdSent.first()) {
                return true;
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return false;
    }
    //Checks if the specific advertisement has been sent before to that device
    public boolean isSpecificAdSent(int id, String bta) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetAdSent;
        try {
            resultSetAdSent = statement.executeQuery("SELECT * FROM `" + this.database + "`.`sentSpecificAd` WHERE `" + this.database + "`.`sentSpecificAd`.`device` LIKE '" + bta + "' AND `" + this.database + "`.`sentSpecificAd`.`advertisement` LIKE '" + id + "'");
            if (resultSetAdSent.first()) {
                return true;
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return false;
    }
    //Sets the general advertisement as sent for that device
    public void setGeneralAdSent(int id, String bta) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetAdSent;
        try {
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Date date = new Date();
            date = new Date(date.getTime());
            resultSetAdSent = statement.executeQuery("SELECT * FROM `" + this.database + "`.`sentGeneralAd`");
            resultSetAdSent.moveToInsertRow();
            resultSetAdSent.updateInt("advertisement", id);
            resultSetAdSent.updateString("device", bta);
            resultSetAdSent.updateString("sendDate", format.format(date));
            resultSetAdSent.insertRow();
            resultSetAdSent.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    //Sets the specific advertisement as sent for that device
    public void setSpecificAdSent(int id, String bta) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        ResultSet resultSetAdSent;
        try {
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Date date = new Date();
            date = new Date(date.getTime());
            resultSetAdSent = statement.executeQuery("SELECT * FROM `" + this.database + "`.`sentSpecificAd`");
            resultSetAdSent.moveToInsertRow();
            resultSetAdSent.updateInt("advertisement", id);
            resultSetAdSent.updateString("device", bta);
            resultSetAdSent.updateString("sendDate", format.format(date));
            resultSetAdSent.insertRow();
            resultSetAdSent.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    /***************************************************************************************************/
    public void addGeneralAd(String id, String description, String image, String application, String startDate, String endDate) {
    }
    public void addSpecificAd(String id, String description, String store, String image, String application, String startDate, String endDate) {
    }
    public void addStore(String name, String zone) {
        Statement statement = null;
        Statement statement2 = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
            statement2 = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        String SQLSentenceStore = "SELECT * FROM `" + this.database + "`.`store`";
        String SQLSentenceZone = "SELECT * FROM `" + this.database + "`.`zone` WHERE `description`='" + zone + "'";
        ResultSet ResulSetStore;
        try {
            ResulSetStore = statement.executeQuery(SQLSentenceStore);
            ResulSetStore.toString();
            ResultSet ResultSetZone;
            ResultSetZone = statement2.executeQuery(SQLSentenceZone);
            if (ResultSetZone.first()) {
                ResulSetStore.moveToInsertRow();
                ResulSetStore.updateString("name", name);
                ResulSetStore.updateInt("zone", ResultSetZone.getInt("id"));
                ResulSetStore.insertRow();
                ResulSetStore.close();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    public void addZone(String description) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        String SQLSentence = "SELECT * FROM `" + this.database + "`.`zone`";
        ResultSet ResultSetZone;
        try {
            ResultSetZone = statement.executeQuery(SQLSentence);
            ResultSetZone.moveToInsertRow();
            ResultSetZone.updateString("description", description);
            ResultSetZone.insertRow();
            ResultSetZone.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    //¿?
    public void deleteRecentDispositives(int zone, long newVisit) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date now = new Date();
        Date date = new Date(now.getTime() - newVisit);
        String limitDate = format.format(date);
        ResultSet resulSet;
        try {
            System.out.println("Borrando los anteriores a " + limitDate);
            resulSet = statement.executeQuery("SELECT * FROM `" + this.database + "`.`dispositive` WHERE `" + this.database + "`.`dispositive`.`lastVisit` IN (SELECT `" + this.database + "`.`visit`.`id` FROM `" + this.database + "`.`visit` WHERE `" + this.database + "`.`visit`.`zone` LIKE " + zone + " AND `visitDate`<= \"" + limitDate + "\")");
            if (resulSet.first()) {
                do {
                    String res = resulSet.getString("mac") + ", " + resulSet.getString("name");
                    System.out.println("Borrando: " + res);
                    resulSet.deleteRow();
                } while (resulSet.next());
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    //TODO
    public Vector<String> getGeneralAdList(String mac) {
        Statement statement2 = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement2 = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        Vector<String> retorno = null;
        try {
            // Ahora acceder a los articulos de bienvenida que no han sido
            // enviados al dispositivo
            String sentenciaGeneral = "SELECT `art`.`description` , `art`.`image`, `art`.`id`, `aplication`.`name`  FROM " +"`" + this.database + "`.`generalAd` as `art`,  " + "`" + this.database + "`.`aplication` as  `aplicacion` " +"where " + "`art`.`id` not in (Select `enviado`.`advertisement` from `sentGeneralAd` as `enviado` where " + "`enviado`.`dispositive`= '" + mac + " ')" + "	and `aplicacion`.`id`=`art`.`aplication";
            ResultSet resulsetGeneral;
            resulsetGeneral = statement2.executeQuery(sentenciaGeneral);
            if (resulsetGeneral.first()) {
                // Recorrer articulos de bienvenida
                retorno = new Vector<String>();
                do {
                    String contenido = resulsetGeneral.getString("description");
                    //Contenido
                    retorno.addElement(contenido);
                    //Imagen
                    retorno.addElement(resulsetGeneral.getString("image"));
                    /*System.out.println("--------"
                     + resulsetGeneral.getString("imagen")
                     + resulsetGeneral.getString("contenido"));
                     */
                    //aplicacion
                    retorno.addElement(resulsetGeneral.getString("name"));
                    //articulo
                    retorno.addElement(String.valueOf(resulsetGeneral.getInt("id")));
                    // Insertar fila en sentSpecificAd
                } while (resulsetGeneral.next());
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return retorno;
    }
    public String[][] getGeneralAds() {
        return null;
    }
    //TODO
    public Vector<String> getSpecificAdList(String mac, int id_zone) {
        Statement statement = null;
        Statement statement2 = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
                    ResultSet.CONCUR_UPDATABLE);
            statement2 = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
                    ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        Vector<String> retorno = new Vector();
        retorno.clear();
        // Se trata de un vector con la siguiente informacion:
        //
        // 2.0-store
        // 2.1 -Articulos del store
        Date ahora = new Date();
        SimpleDateFormat formato = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        // 1 -Busca el name de la tienda
        // 2.- Buscar articulos para esa tienda
        // Tener en cuenta fecha y hora.
        String sentenciaTienda = "SELECT * FROM `" + this.database + "`.`store` where `zone` =" + id_zone;
        ResultSet resulsetTienda;
        try {
            resulsetTienda = statement.executeQuery(sentenciaTienda);
            // no se encuentra el servicio en la base de datos.
            String sentenciaArticulo = null;
            ResultSet resulsetArticulo;
            if (resulsetTienda.first()) {
                do {
                    String nameTienda = resulsetTienda.getString("name");
                    // recorre las filas obtenidas. Cada fila es una tienda
                    sentenciaArticulo = "SELECT  `art`.`description` , `art`.`image`, `art`.`id`," +
                            "`art`.`endDate`,  `aplicacion`.`name` FROM " +"`" + this.database + "`.`specificAd`  as `art`,  " +"`" + this.database + "`.`application` as  `aplicacion` " +"where `art`.`store`='" + resulsetTienda.getInt("id") + "' " + "AND `art`.`startDate` <= '" + formato.format(ahora) + "' AND `art`.`endDate` >= '" + formato.format(ahora) + "'" + "AND `aplication`.`id`=`art`.`id";
                    resulsetArticulo = statement2.executeQuery(sentenciaArticulo);
                    // en este resulset se encuentran los articulos.
                    // comprobar si hay articulos
                    if (resulsetArticulo.first()) {
                        do {
                            //Comprobar si se ha enviado articulo al dispositivo
                            //if(!this.isSpecificAdSent(mac, resulsetArticulo.getString("id"))){
                            String informacion = null;
                            SimpleDateFormat formatoFecha = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                            informacion = nameTienda + " informa de oferta: " + resulsetArticulo.getString("contenido") + " Oferta valida hasta " + formatoFecha.format(resulsetArticulo.getDate("fecha_fin"));
                            //Contenido
                            retorno.addElement(informacion);
                            //Imagen
                            retorno.addElement(resulsetArticulo.getString("imagen"));
                            //Aplicacion
                            retorno.addElement(resulsetArticulo.getString("name"));
                            //Identificador
                            retorno.addElement(resulsetArticulo.getString("codigoOferta"));
                            //}
                            //this.setsentSpecificAd(mac, resulsetArticulo.getString("codigoOferta") );
                        } while (resulsetArticulo.next());
                    } else {
                    }
                } while (resulsetTienda.next());
            } else {
            }
        } catch (SQLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        if (retorno.isEmpty()) {
        }
        return retorno;
    }
    //TODO
    public String[][] getSpecificAds() {
        return null;
    }
    public String[][] getStores() {
        Statement statement = null;
        Statement statement2 = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
            statement2 = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        Vector<String> stores = new Vector<String>();
        String SQLSentenceStore = "SELECT * FROM `" + this.database + "`.`store` ";
        ResultSet ResultSetStore;
        try {
            ResultSetStore = statement.executeQuery(SQLSentenceStore);
            ResultSet ResultSetZone;
            if (ResultSetStore.first()) {
                do {
                    String SQLSentenceZone = "SELECT * FROM `" + this.database + "`.`zone` where  `id`='" + ResultSetStore.getInt("zone") + "'";
                    ResultSetZone = statement2.executeQuery(SQLSentenceZone);
                    if (ResultSetZone.first()) {
                        stores.add(ResultSetStore.getString("name"));
                        stores.add(ResultSetZone.getString("description"));
                    }
                } while (ResultSetStore.next());
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        String arrayStores[][] = new String[stores.size() / 2][2];
        for (int i = 0; i < arrayStores.length; i++) {
            arrayStores[i][0] = stores.elementAt(2 * i);
            arrayStores[i][1] = stores.elementAt((2 * i) + 1);
        }
        return arrayStores;
    }
    //TODO
    public Vector<String> getStoreZone(String name) {
        Statement statement = null;
        Statement statement2 = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
            statement2 = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        }
        catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
        Vector<String> retorno = new Vector();
        //En primer lugar busca la zone del store donde se encuentra la tienda
        String sentenciaTienda = null;
        if (name != null) {
            sentenciaTienda = "SELECT * FROM `" + this.database + "`.`store` where `name`='" + name + "'";
            ResultSet resulsetTienda;
            String zone = new String();
            try {
                resulsetTienda = statement.executeQuery(sentenciaTienda);
                ResultSet resulsetzone;
                if (resulsetTienda.first()) {
                    String sentenciazone = "SELECT * FROM `" + this.database + "`.`zone` where  `id`='" + resulsetTienda.getString("zone") + "'";
                    resulsetzone = statement2.executeQuery(sentenciazone);
                    if (resulsetzone.first()) {
                        retorno.add(resulsetzone.getString("description"));
                        zone = resulsetTienda.getString("zone");
                    }
                }
            }
            catch (SQLException e) {
                e.printStackTrace();
            }
            //Ahora se buscan las otras zones
            try {
                String sentenciazone = "SELECT * FROM `" + this.database + "`.`zone` where  `id` not like order by `description`'" + zone + "'";
                ResultSet resulsetzone;
                resulsetzone = statement2.executeQuery(sentenciazone);
                if (resulsetzone.first()) {
                    do {
                        retorno.add(resulsetzone.getString("description"));
                    } 
                    while (resulsetzone.next());
                }
            }
            catch (SQLException e) {
                e.printStackTrace();
            }
        }
        else {
            String sentenciazone = "SELECT * FROM `" + this.database + "`.`zone` order by `description`";
            ResultSet resulsetzone;
            try {
                resulsetzone = statement2.executeQuery(sentenciazone);
                if (resulsetzone.first()) {
                    do {
                        retorno.add(resulsetzone.getString("description"));
                    }
                    while (resulsetzone.next());
                }
            }
            catch (SQLException e) {
                e.printStackTrace();
            }
        }
        return retorno;
    }
    public int getZoneID(int zone) {
        return 0;
    }
    public String[][] getZones() {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        }
        catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
        Vector<String> zones = new Vector<String>();
        String SQLSentence = "SELECT * FROM `" + this.database + "`.`zone` ";
        ResultSet resultSet;
        try {
            resultSet = statement.executeQuery(SQLSentence);
            if (resultSet.first()) {
                do {
                    zones.add(resultSet.getString("description"));
                }
                while (resultSet.next());
            }
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
        String arrayZones[][] = new String[zones.size()][1];
        for (int i = 0; i < zones.size(); i++) {
            arrayZones[i][0] = zones.elementAt(i);
        }
        return arrayZones;
    }
    //TODO
    public void removeGeneralAd(String id) {
    }
    //TODO
    public void removeSpecificAd(String id) {
    }
    public void removeStore(String name) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        }
        catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
        String SQLSentence = "SELECT * FROM `" + this.database + "`.`store` where `name` = '" + name + "'";
        ResultSet ResultSet;
        try {
            ResultSet = statement.executeQuery(SQLSentence);
            if (ResultSet.first()) {
                do {
                    ResultSet.deleteRow();
                }
                while (ResultSet.next());
            }
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
    }
    public void removeZone(String description) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
        }
        catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
        String SQLSentence = "SELECT * FROM `" + this.database + "`.`zone` where `description` = '" + description + "'";
        ResultSet ResultSet;
        try {
            ResultSet = statement.executeQuery(SQLSentence);
            if (ResultSet.first()) {
                do {
                    ResultSet.deleteRow();
                }
                while (ResultSet.next());
            }
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
    }
    //TODO
    public void updateStoreInfo(String name, String zone, String nameAntiguo) {
        Statement statement = null;
        Statement statement2 = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);
            statement2 = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);
        }
        catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
        if (nameAntiguo != null) {
            String sentenciaTienda = "SELECT * FROM `" + this.database + "`.`store` where `name`='" + nameAntiguo + "'";
            ResultSet resulsetTienda;
            try {
                resulsetTienda = statement.executeQuery(sentenciaTienda);
                if (resulsetTienda.first()) {String sentenciazone = "SELECT * FROM `" + this.database + "`.`zone` where  `description` like '" + zone + "'";
                ResultSet resulsetzone;
                resulsetzone = statement2.executeQuery(sentenciazone);
                if (resulsetzone.first()) {
                    int id_zone = resulsetzone.getInt("id");
                    resulsetTienda.moveToCurrentRow();
                    resulsetTienda.updateInt("zone", id_zone);
                    resulsetTienda.updateString("name", name);
                    resulsetTienda.updateRow();
                }
                resulsetTienda.close();
                resulsetzone.close();
                }
            }
            catch (SQLException e) {
                e.printStackTrace();
            }
        }
        else {
            String sentenciaTienda = "SELECT * FROM `" + this.database + "`.`store` ";
            ResultSet resulsetTienda;
            try {
                resulsetTienda = statement.executeQuery(sentenciaTienda);
                String sentenciazone = "SELECT * FROM `" + this.database + "`.`zone` where  `description` like '" + zone + "'";
                ResultSet resulsetzone;
                resulsetzone = statement2.executeQuery(sentenciazone);
                if (resulsetzone.first()) {
                    resulsetTienda.moveToInsertRow();
                    resulsetTienda.updateString("name", name);
                    resulsetTienda.updateInt("zone", resulsetzone.getInt("id"));
                    resulsetTienda.insertRow();
                }
            }
            catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }
    public void updateVisits(String mac, int id_zone, long tnuevavisita) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);
        }
        catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
        String sentencia = "SELECT * FROM `" + this.database + "`.`visit` where `dispositive` like '" + mac + "' order by `visitDate` desc";
        // obtiene visitas del dispositivo identificado por mac. La primera fila
        // es la ultima visita
        ResultSet resulsetVisita;
        try {
            resulsetVisita = statement.executeQuery(sentencia);
            // Si es la primera vez insertar. Sino comprobar si es una nueva
            // visita.
            if (!resulsetVisita.first()) {
                Date now = new Date();
                resulsetVisita.moveToInsertRow();
                SimpleDateFormat formato = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                Date fecha;
                fecha = new Date(now.getTime());
                resulsetVisita.updateString("mac", mac);
                resulsetVisita.updateString("visitDate", formato.format(fecha));
                resulsetVisita.updateInt("zone", id_zone);
                resulsetVisita.insertRow();
                resulsetVisita.close();
                System.out.println("Primera visita");
            }
            else {
                Date now = new Date();
                String visitDate_cadena = resulsetVisita.getString("visitDate");
                // quitar .0 final. Limpiar cadena.
                // visitDate_cadena.substring(0, 19);
                SimpleDateFormat formato = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                Date d = null;
                try {
                    d = formato.parse(visitDate_cadena.substring(0, 19));
                }
                catch (ParseException e) {
                    System.out.println("Error en la fecha de la base de datos");
                }
                Date antigua = new Date(d.getTime() + tnuevavisita);
                //long diferencia = now.getTime() - d.getTime();
                if (antigua.compareTo(now) <= 0) {
                    // actualizar tabla insertando informacion de la nueva
                    // visita
                    resulsetVisita.moveToInsertRow();
                    // SimpleDateFormat formato = new SimpleDateFormat(
                    // "yyyy-MM-dd HH:mm:ss");
                    Date fecha;
                    fecha = new Date(now.getTime());
                    resulsetVisita.updateString("mac", mac);
                    resulsetVisita.updateString("visitDate", formato.format(fecha));
                    resulsetVisita.updateInt("zone", id_zone);
                    resulsetVisita.insertRow();
                    resulsetVisita.close();
                }
            }
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
    }
    //TODO
    public void updateZoneInfo(String description, String descAntigua) {
        Statement statement = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
            this.conn = DriverManager.getConnection(this.url);
            statement = DriverManager.getConnection(this.url).createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);
        }
        catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
        if (descAntigua != null) {
            String sentenciaTienda = "SELECT * FROM `" + this.database + "`.`zone` where `description` like '" + descAntigua + "'";
            ResultSet resulsetzone;
            try {
                resulsetzone = statement.executeQuery(sentenciaTienda);
                if (resulsetzone.first()) {
                    resulsetzone.moveToCurrentRow();
                    resulsetzone.updateString("description", description);
                    resulsetzone.updateRow();
                }
                resulsetzone.close();
            }
            catch (SQLException e) {
                e.printStackTrace();
            }
        }
        else {
            String sentenciazone = "SELECT * FROM `" + this.database + "`.`zone` ";
            ResultSet resulsetzone;
            try {
                resulsetzone = statement.executeQuery(sentenciazone);
                if (resulsetzone.first()) {
                    resulsetzone.moveToInsertRow();
                    resulsetzone.updateString("description", description);
                    resulsetzone.insertRow();
                }
            }
            catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }
}